%
% fdm_bc
%
% apply boundary conditions
%

numnp = size(xnod,1);

rowg = []; colg = []; coeg = [];

for i=1:Nx,
    for j=1:Ny,
        Indx(i+1,j+1)=(j-1)*Nx+i;
        Indx_inv(Indx(i+1,j+1),1)=i+1;
        Indx_inv(Indx(i+1,j+1),2)=j+1;
    end;
end

% Dirichlet boundary conditions
nodes = bc.Dirichlet.nodes;

rows = nodes; cols = rows; coef = ones(length(nodes),1);
rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

R(nodes,1) = 0;
%=========================================================================

% Neumann boundary condition
if isempty(bc.Neumann.nodes)==0
    nodes = bc.Neumann.nodes;
    flujo = bc.Neumann.value;
    normx = bc.Neumann.normal(:,1);
    normy = bc.Neumann.normal(:,2);

    % generamos los nodos ficticios correspondientes a las normales
    % ubicamos el nodo interior
    IIs = Indx_inv(nodes,1);
    JJs = Indx_inv(nodes,2);
    IIs_int = IIs-sign(normx);
    JJs_int = JJs-sign(normy);
    IIs_ext = IIs+sign(normx);
    JJs_ext = JJs+sign(normy);
    for k=1:length(nodes)
        nodes_int(k) = Indx(IIs_int(k),JJs_int(k));
        Indx(IIs_ext(k),JJs_ext(k)) = numnp+k;
        Indx_inv(numnp+k,1) = IIs_ext(k);
        Indx_inv(numnp+k,2) = JJs_ext(k);
        dx = xnod(nodes(k),1)-xnod(nodes_int(k),1);
        dy = xnod(nodes(k),2)-xnod(nodes_int(k),2);
        xnod(numnp+k,1) = xnod(nodes(k),1) + dx;
        xnod(numnp+k,2) = xnod(nodes(k),2) + dy;
        nodes_ext(k) = Indx(IIs_ext(k),JJs_ext(k));
        state(nodes_ext(k),1) = state(nodes(k),1);
    end
end

% remuevo los nodos que tienen fijaciones
nodes_int = (1:numnp)';
nodes_int(bc.Dirichlet.nodes) = [];
data.nodes_int = nodes_int;
